// /////////////////////////////////////////////////////////////////////////
// C++ code automatically generated by hif2sc
// Part of HIFSuite - Version stable
// Site: www.hifsuite.com - Contact: hifsuite@edalab.it
//
// HIFSuite copyright: EDALab s.r.l. - Networked Embedded Systems
// Site: www.edalab.it - Contact: info@edalab.it
// /////////////////////////////////////////////////////////////////////////


#include "../inc/watchdog_apb_wrapper.hpp"



void watchdog_apb_wrapper::hif_cone_max_counter()
{
    max_counter = *hif_a2t_data.pwdata;
}


void watchdog_apb_wrapper::hif_cone_prdata_partial0()
{
    prdata_partial0 = actual_counter;
}


void watchdog_apb_wrapper::hif_cone_prdata_partial1()
{
    prdata_partial1 = counter_flag;
}


void watchdog_apb_wrapper::hif_cone_start_counting()
{
    start_counting = *hif_a2t_data.pwdata >> 16UL & 1UL;
}


void watchdog_apb_wrapper::hif_cone_stop_counting()
{
    stop_counting = *hif_a2t_data.pwdata >> 24UL & 1UL;
}


void watchdog_apb_wrapper::hif_cone_watchdog_0_state()
{
    if (static_cast< uint8_t >( old_watchdog_0_state & uint8_t(7U) ) != static_cast<
         uint8_t >( watchdog_0_state & uint8_t(7U) ))
    {
        old_watchdog_0_state = watchdog_0_state & uint8_t(7U);
        watchdog_0_state_sig_var = old_watchdog_0_state & uint8_t(7U);
    }
}



watchdog_apb_wrapper::watchdog_apb_wrapper() :
    pwdata_old(0UL),
    pwrite_old(false),
    penable_old(false),
    psel_old(false),
    paddr_old(0UL),
    presetn_old(false),
    pclk_old(false),
    hif_a2t_data(
    nullptr,
    nullptr,
    nullptr,
    nullptr,
    nullptr,
    nullptr,
    nullptr,
    nullptr,
    nullptr),
    prdata_mspw(),
    prdata_partial2(uint16_t(0U)),
    prdata_partial1(false),
    prdata_partial0(uint16_t(0U)),
    start_counting(false),
    stop_counting(false),
    max_counter(uint16_t(0U)),
    actual_counter(uint16_t(0U)),
    counter_flag(false),
    dout_rdy(false),
    watchdog_0_state(uint8_t(0U)),
    old_watchdog_0_state(uint8_t(0U)),
    watchdog_0_state_sig_var(uint8_t(0U)),
    watchdog_0_next_state(uint8_t(0U)),
    watchdog_0_internal_max_counter(0UL),
    prdata_mspw_new(),
    prdata_partial2_new(uint16_t(0U)),
    actual_counter_new(uint16_t(0U)),
    counter_flag_new(false),
    dout_rdy_new(false),
    watchdog_0_state_new(uint8_t(0U)),
    watchdog_0_next_state_new(uint8_t(0U)),
    watchdog_0_internal_max_counter_new(0UL),
    process_in_queue(false),
    flag_watchdog_0_initial_process_executed(false),
    flag_watchdog_0_process_executed(false),
    flag_watchdog_0_state(false),
    flag_pwdata(false),
    flag_watchdog_0_process_0_executed(false),
    flag_pos_pclk(false),
    flag_dout_rdy(false),
    flag_globact_process_0_executed(false),
    flag_actual_counter(false),
    flag_globact_process_1_executed(false),
    flag_counter_flag(false),
    flag_globact_process_2_executed(false),
    flag_prdata_partial2(false),
    flag_prdata_mspw(false),
    watchdog_0_st_1(uint8_t(0U)),
    watchdog_0_st_2(uint8_t(1U)),
    watchdog_0_st_3(uint8_t(2U)),
    watchdog_0_st_4(uint8_t(3U)),
    watchdog_0_st_5(uint8_t(4U))

{
    for (int ind = 31L; ind >= 0L; ind = ind - 1)
    {
        prdata_mspw[ind] = false;
    }
    for (int ind_0 = 31L; ind_0 >= 0L; ind_0 = ind_0 - 1)
    {
        prdata_mspw_new[ind_0] = false;
    }

}


watchdog_apb_wrapper::~watchdog_apb_wrapper()
{}


void watchdog_apb_wrapper::watchdog_0_initial_process()
{
    hif_cone_watchdog_0_state();
    watchdog_0_state_sig_var = watchdog_0_st_1 & uint8_t(7U);
    watchdog_0_state_new = watchdog_0_state_sig_var & uint8_t(7U);
    watchdog_0_next_state_new = watchdog_0_st_1 & uint8_t(7U);
    actual_counter_new = uint16_t(0U);
    counter_flag_new = false;
}


void watchdog_apb_wrapper::watchdog_0_process()
{
    hif_cone_watchdog_0_state();
    if (watchdog_0_st_1 == watchdog_0_state_sig_var)
    {
        hif_cone_start_counting();
        if (start_counting == true)
        {
            watchdog_0_next_state_new = watchdog_0_st_2 & uint8_t(7U);
        }
    }
    else if (watchdog_0_st_2 == watchdog_0_state_sig_var)
    {
        hif_cone_stop_counting();
        if (stop_counting == true)
        {
            watchdog_0_next_state_new = watchdog_0_st_3 & uint8_t(7U);
        }
    }
    else if (watchdog_0_st_3 == watchdog_0_state_sig_var)
    {
        watchdog_0_next_state_new = watchdog_0_st_4 & uint8_t(7U);
    }
    else if (watchdog_0_st_4 == watchdog_0_state_sig_var)
    {
        hif_cone_start_counting();
        if (start_counting == true)
        {
            watchdog_0_next_state_new = watchdog_0_st_5 & uint8_t(7U);
        }
    }
    else if (watchdog_0_st_5 == watchdog_0_state_sig_var)
    {
        watchdog_0_next_state_new = watchdog_0_st_2 & uint8_t(7U);
    }
}


void watchdog_apb_wrapper::watchdog_0_process_0()
{
    hif_cone_watchdog_0_state();
    watchdog_0_state_new = watchdog_0_next_state & uint8_t(7U);
    if (watchdog_0_next_state == watchdog_0_st_1)
    {
        hif_cone_max_counter();
        watchdog_0_internal_max_counter_new = max_counter;
        actual_counter_new = uint16_t(0U);
        counter_flag_new = false;
        dout_rdy_new = false;
    }
    else if (watchdog_0_next_state == watchdog_0_st_2)
    {
        actual_counter_new = actual_counter + 2UL;
        if (actual_counter >= watchdog_0_internal_max_counter + 1260UL)
        {
            counter_flag_new = true;
        }
        dout_rdy_new = false;
    }
    else if (watchdog_0_next_state == watchdog_0_st_3)
    {
        actual_counter_new = actual_counter - uint16_t(1260U);
        dout_rdy_new = false;
    }
    else if (watchdog_0_next_state == watchdog_0_st_4)
    {
        dout_rdy_new = true;
        hif_cone_max_counter();
        watchdog_0_internal_max_counter_new = max_counter;
    }
    else if (watchdog_0_next_state == watchdog_0_st_5)
    {
        actual_counter_new = uint16_t(0U);
        counter_flag_new = false;
        dout_rdy_new = false;
    }
}


void watchdog_apb_wrapper::globact_process()
{
    *hif_a2t_data.pready = dout_rdy;
}


void watchdog_apb_wrapper::globact_process_0()
{
    hif_cone_prdata_partial0();
    prdata_mspw_new[15L] = static_cast< uint16_t >( prdata_partial0 >> uint16_t
        (15U) ) & uint16_t(1U);
    prdata_mspw_new[14L] = static_cast< uint16_t >( prdata_partial0 >> uint16_t
        (14U) ) & uint16_t(1U);
    prdata_mspw_new[13L] = static_cast< uint16_t >( prdata_partial0 >> uint16_t
        (13U) ) & uint16_t(1U);
    prdata_mspw_new[12L] = static_cast< uint16_t >( prdata_partial0 >> uint16_t
        (12U) ) & uint16_t(1U);
    prdata_mspw_new[11L] = static_cast< uint16_t >( prdata_partial0 >> uint16_t
        (11U) ) & uint16_t(1U);
    prdata_mspw_new[10L] = static_cast< uint16_t >( prdata_partial0 >> uint16_t
        (10U) ) & uint16_t(1U);
    prdata_mspw_new[9L] = static_cast< uint16_t >( prdata_partial0 >> uint16_t(9U
        ) ) & uint16_t(1U);
    prdata_mspw_new[8L] = static_cast< uint16_t >( prdata_partial0 >> uint16_t(8U
        ) ) & uint16_t(1U);
    prdata_mspw_new[7L] = static_cast< uint16_t >( prdata_partial0 >> uint16_t(7U
        ) ) & uint16_t(1U);
    prdata_mspw_new[6L] = static_cast< uint16_t >( prdata_partial0 >> uint16_t(6U
        ) ) & uint16_t(1U);
    prdata_mspw_new[5L] = static_cast< uint16_t >( prdata_partial0 >> uint16_t(5U
        ) ) & uint16_t(1U);
    prdata_mspw_new[4L] = static_cast< uint16_t >( prdata_partial0 >> uint16_t(4U
        ) ) & uint16_t(1U);
    prdata_mspw_new[3L] = static_cast< uint16_t >( prdata_partial0 >> uint16_t(3U
        ) ) & uint16_t(1U);
    prdata_mspw_new[2L] = static_cast< uint16_t >( prdata_partial0 >> uint16_t(2U
        ) ) & uint16_t(1U);
    prdata_mspw_new[1L] = static_cast< uint16_t >( prdata_partial0 >> uint16_t(1U
        ) ) & uint16_t(1U);
    prdata_mspw_new[0L] = prdata_partial0 & uint16_t(1U);
}


void watchdog_apb_wrapper::globact_process_1()
{
    hif_cone_prdata_partial1();
    prdata_mspw_new[16L] = prdata_partial1;
}


void watchdog_apb_wrapper::globact_process_2()
{
    prdata_mspw_new[31L] = static_cast< uint16_t >( prdata_partial2 >> uint16_t
        (14U) ) & uint16_t(1U);
    prdata_mspw_new[30L] = static_cast< uint16_t >( prdata_partial2 >> uint16_t
        (13U) ) & uint16_t(1U);
    prdata_mspw_new[29L] = static_cast< uint16_t >( prdata_partial2 >> uint16_t
        (12U) ) & uint16_t(1U);
    prdata_mspw_new[28L] = static_cast< uint16_t >( prdata_partial2 >> uint16_t
        (11U) ) & uint16_t(1U);
    prdata_mspw_new[27L] = static_cast< uint16_t >( prdata_partial2 >> uint16_t
        (10U) ) & uint16_t(1U);
    prdata_mspw_new[26L] = static_cast< uint16_t >( prdata_partial2 >> uint16_t
        (9U) ) & uint16_t(1U);
    prdata_mspw_new[25L] = static_cast< uint16_t >( prdata_partial2 >> uint16_t
        (8U) ) & uint16_t(1U);
    prdata_mspw_new[24L] = static_cast< uint16_t >( prdata_partial2 >> uint16_t
        (7U) ) & uint16_t(1U);
    prdata_mspw_new[23L] = static_cast< uint16_t >( prdata_partial2 >> uint16_t
        (6U) ) & uint16_t(1U);
    prdata_mspw_new[22L] = static_cast< uint16_t >( prdata_partial2 >> uint16_t
        (5U) ) & uint16_t(1U);
    prdata_mspw_new[21L] = static_cast< uint16_t >( prdata_partial2 >> uint16_t
        (4U) ) & uint16_t(1U);
    prdata_mspw_new[20L] = static_cast< uint16_t >( prdata_partial2 >> uint16_t
        (3U) ) & uint16_t(1U);
    prdata_mspw_new[19L] = static_cast< uint16_t >( prdata_partial2 >> uint16_t
        (2U) ) & uint16_t(1U);
    prdata_mspw_new[18L] = static_cast< uint16_t >( prdata_partial2 >> uint16_t
        (1U) ) & uint16_t(1U);
    prdata_mspw_new[17L] = prdata_partial2 & uint16_t(1U);
}


void watchdog_apb_wrapper::prdata_mspw_proc_tgt()
{
    *hif_a2t_data.prdata = static_cast< uint32_t >( prdata_mspw[1L] ) << 1L | prdata_mspw
        [0L] | static_cast< uint32_t >( prdata_mspw[2L] ) << 2L | static_cast< uint32_t
         >( prdata_mspw[3L] ) << 3L | static_cast< uint32_t >( prdata_mspw[4L] 
        ) << 4L | static_cast< uint32_t >( prdata_mspw[5L] ) << 5L | static_cast<
         uint32_t >( prdata_mspw[6L] ) << 6L | static_cast< uint32_t >( prdata_mspw
        [7L] ) << 7L | static_cast< uint32_t >( prdata_mspw[8L] ) << 8L | static_cast<
         uint32_t >( prdata_mspw[9L] ) << 9L | static_cast< uint32_t >( prdata_mspw
        [10L] ) << 10L | static_cast< uint32_t >( prdata_mspw[11L] ) << 11L | static_cast<
         uint32_t >( prdata_mspw[12L] ) << 12L | static_cast< uint32_t >( prdata_mspw
        [13L] ) << 13L | static_cast< uint32_t >( prdata_mspw[14L] ) << 14L | static_cast<
         uint32_t >( prdata_mspw[15L] ) << 15L | static_cast< uint32_t >( prdata_mspw
        [16L] ) << 16L | static_cast< uint32_t >( prdata_mspw[17L] ) << 17L | static_cast<
         uint32_t >( prdata_mspw[18L] ) << 18L | static_cast< uint32_t >( prdata_mspw
        [19L] ) << 19L | static_cast< uint32_t >( prdata_mspw[20L] ) << 20L | static_cast<
         uint32_t >( prdata_mspw[21L] ) << 21L | static_cast< uint32_t >( prdata_mspw
        [22L] ) << 22L | static_cast< uint32_t >( prdata_mspw[23L] ) << 23L | static_cast<
         uint32_t >( prdata_mspw[24L] ) << 24L | static_cast< uint32_t >( prdata_mspw
        [25L] ) << 25L | static_cast< uint32_t >( prdata_mspw[26L] ) << 26L | static_cast<
         uint32_t >( prdata_mspw[27L] ) << 27L | static_cast< uint32_t >( prdata_mspw
        [28L] ) << 28L | static_cast< uint32_t >( prdata_mspw[29L] ) << 29L | static_cast<
         uint32_t >( prdata_mspw[30L] ) << 30L | static_cast< uint32_t >( prdata_mspw
        [31L] ) << 31L;
}


void watchdog_apb_wrapper::update_input_queue( bool synch_phase )
{
    process_in_queue = false;
    if (*hif_a2t_data.pclk != pclk_old)
    {
        pclk_old = *hif_a2t_data.pclk;
        if (*hif_a2t_data.pclk == true)
        {
            flag_pos_pclk = true;
        }
        else
        {
            flag_pos_pclk = false;
        }
        process_in_queue = true;
    }
    else
    {
        flag_pos_pclk = false;
    }
    presetn_old = *hif_a2t_data.presetn;
    paddr_old = *hif_a2t_data.paddr;
    psel_old = *hif_a2t_data.psel;
    penable_old = *hif_a2t_data.penable;
    pwrite_old = *hif_a2t_data.pwrite;
    if (*hif_a2t_data.pwdata != pwdata_old)
    {
        pwdata_old = *hif_a2t_data.pwdata;
        flag_pwdata = true;
        process_in_queue = true;
    }
    else
    {
        flag_pwdata = false;
    }
}


void watchdog_apb_wrapper::update_event_queue()
{
    process_in_queue = false;
    update_input_queue( false );
    if (actual_counter != actual_counter_new)
    {
        actual_counter = actual_counter_new;
        flag_actual_counter = true;
        process_in_queue = true;
    }
    else
    {
        flag_actual_counter = false;
    }
    if (counter_flag != counter_flag_new)
    {
        counter_flag = counter_flag_new;
        flag_counter_flag = true;
        process_in_queue = true;
    }
    else
    {
        flag_counter_flag = false;
    }
    if (flag_watchdog_0_process_0_executed && dout_rdy != dout_rdy_new)
    {
        dout_rdy = dout_rdy_new;
        flag_dout_rdy = true;
        process_in_queue = true;
    }
    else
    {
        flag_dout_rdy = false;
    }
    if (!(prdata_mspw[0L] == prdata_mspw_new[0L] && prdata_mspw[1L] == prdata_mspw_new
        [1L] && prdata_mspw[2L] == prdata_mspw_new[2L] && prdata_mspw[3L] == prdata_mspw_new
        [3L] && prdata_mspw[4L] == prdata_mspw_new[4L] && prdata_mspw[5L] == prdata_mspw_new
        [5L] && prdata_mspw[6L] == prdata_mspw_new[6L] && prdata_mspw[7L] == prdata_mspw_new
        [7L] && prdata_mspw[8L] == prdata_mspw_new[8L] && prdata_mspw[9L] == prdata_mspw_new
        [9L] && prdata_mspw[10L] == prdata_mspw_new[10L] && prdata_mspw[11L] ==
         prdata_mspw_new[11L] && prdata_mspw[12L] == prdata_mspw_new[12L] && prdata_mspw
        [13L] == prdata_mspw_new[13L] && prdata_mspw[14L] == prdata_mspw_new[14L
        ] && prdata_mspw[15L] == prdata_mspw_new[15L] && prdata_mspw[16L] == prdata_mspw_new
        [16L] && prdata_mspw[17L] == prdata_mspw_new[17L] && prdata_mspw[18L] ==
         prdata_mspw_new[18L] && prdata_mspw[19L] == prdata_mspw_new[19L] && prdata_mspw
        [20L] == prdata_mspw_new[20L] && prdata_mspw[21L] == prdata_mspw_new[21L
        ] && prdata_mspw[22L] == prdata_mspw_new[22L] && prdata_mspw[23L] == prdata_mspw_new
        [23L] && prdata_mspw[24L] == prdata_mspw_new[24L] && prdata_mspw[25L] ==
         prdata_mspw_new[25L] && prdata_mspw[26L] == prdata_mspw_new[26L] && prdata_mspw
        [27L] == prdata_mspw_new[27L] && prdata_mspw[28L] == prdata_mspw_new[28L
        ] && prdata_mspw[29L] == prdata_mspw_new[29L] && prdata_mspw[30L] == prdata_mspw_new
        [30L] && prdata_mspw[31L] == prdata_mspw_new[31L]))
    {
        prdata_mspw[31L] = prdata_mspw_new[31L];
        prdata_mspw[30L] = prdata_mspw_new[30L];
        prdata_mspw[29L] = prdata_mspw_new[29L];
        prdata_mspw[28L] = prdata_mspw_new[28L];
        prdata_mspw[27L] = prdata_mspw_new[27L];
        prdata_mspw[26L] = prdata_mspw_new[26L];
        prdata_mspw[25L] = prdata_mspw_new[25L];
        prdata_mspw[24L] = prdata_mspw_new[24L];
        prdata_mspw[23L] = prdata_mspw_new[23L];
        prdata_mspw[22L] = prdata_mspw_new[22L];
        prdata_mspw[21L] = prdata_mspw_new[21L];
        prdata_mspw[20L] = prdata_mspw_new[20L];
        prdata_mspw[19L] = prdata_mspw_new[19L];
        prdata_mspw[18L] = prdata_mspw_new[18L];
        prdata_mspw[17L] = prdata_mspw_new[17L];
        prdata_mspw[16L] = prdata_mspw_new[16L];
        prdata_mspw[15L] = prdata_mspw_new[15L];
        prdata_mspw[14L] = prdata_mspw_new[14L];
        prdata_mspw[13L] = prdata_mspw_new[13L];
        prdata_mspw[12L] = prdata_mspw_new[12L];
        prdata_mspw[11L] = prdata_mspw_new[11L];
        prdata_mspw[10L] = prdata_mspw_new[10L];
        prdata_mspw[9L] = prdata_mspw_new[9L];
        prdata_mspw[8L] = prdata_mspw_new[8L];
        prdata_mspw[7L] = prdata_mspw_new[7L];
        prdata_mspw[6L] = prdata_mspw_new[6L];
        prdata_mspw[5L] = prdata_mspw_new[5L];
        prdata_mspw[4L] = prdata_mspw_new[4L];
        prdata_mspw[3L] = prdata_mspw_new[3L];
        prdata_mspw[2L] = prdata_mspw_new[2L];
        prdata_mspw[1L] = prdata_mspw_new[1L];
        prdata_mspw[0L] = prdata_mspw_new[0L];
        flag_prdata_mspw = true;
        process_in_queue = true;
    }
    else
    {
        flag_prdata_mspw = false;
    }
    if (prdata_partial2 != prdata_partial2_new)
    {
        prdata_partial2 = prdata_partial2_new;
        flag_prdata_partial2 = true;
        process_in_queue = true;
    }
    else
    {
        flag_prdata_partial2 = false;
    }
    watchdog_0_internal_max_counter = watchdog_0_internal_max_counter_new;
    watchdog_0_next_state = watchdog_0_next_state_new;
    if (watchdog_0_state != watchdog_0_state_new)
    {
        watchdog_0_state = watchdog_0_state_new;
        flag_watchdog_0_state = true;
        process_in_queue = true;
    }
    else
    {
        flag_watchdog_0_state = false;
    }
}


void watchdog_apb_wrapper::flag_elaboration()
{
    flag_watchdog_0_process_executed = false;
    if (flag_watchdog_0_state || flag_pwdata)
    {
        watchdog_0_process();
        flag_watchdog_0_process_executed = true;
    }
    flag_watchdog_0_process_0_executed = false;
    if (flag_pos_pclk)
    {
        watchdog_0_process_0();
        flag_watchdog_0_process_0_executed = true;
    }
    if (flag_dout_rdy)
    {
        globact_process();
    }
    flag_globact_process_0_executed = false;
    if (flag_actual_counter)
    {
        globact_process_0();
        flag_globact_process_0_executed = true;
    }
    flag_globact_process_1_executed = false;
    if (flag_counter_flag)
    {
        globact_process_1();
        flag_globact_process_1_executed = true;
    }
    flag_globact_process_2_executed = false;
    if (flag_prdata_partial2)
    {
        globact_process_2();
        flag_globact_process_2_executed = true;
    }
    if (flag_prdata_mspw)
    {
        prdata_mspw_proc_tgt();
    }
}


void watchdog_apb_wrapper::start_of_simulation()
{
    watchdog_0_initial_process();
    flag_watchdog_0_initial_process_executed = true;
    watchdog_0_process();
    flag_watchdog_0_process_executed = true;
    watchdog_0_process_0();
    flag_watchdog_0_process_0_executed = true;
    globact_process();
    globact_process_0();
    flag_globact_process_0_executed = true;
    globact_process_1();
    flag_globact_process_1_executed = true;
    globact_process_2();
    flag_globact_process_2_executed = true;
    prdata_mspw_proc_tgt();
}


void watchdog_apb_wrapper::initialize()
{
    start_of_simulation();
}




